import os
import ntpath
import re
from typing import List,Dict,Tuple
from functools import cmp_to_key
import itertools

def get_root_path(root_name:str,leaf_path:str):
    splited_paths=str(os.path.dirname(os.path.abspath(leaf_path))).split(ntpath.sep)
    splited_paths_until_root=[]
    for word in splited_paths:
        splited_paths_until_root.append(word)
        if word==root_name:
            break
    return ntpath.sep.join(splited_paths_until_root)+ntpath.sep

def get_single_dict(root_obj):
    ret:dict=dict()
    def recursive_func(obj,s:str):
        if hasattr(obj,"__dict__"):
            recursive_func(obj.__dict__,s)
        elif type(obj) is dict:
            for key,value in obj.items():
                if key in ["__objclass__"]:
                    continue
                recursive_func(value,key if s=="" else f"{s}.{key}")
        elif type(obj) is list:
            for i,value in enumerate(obj):
                recursive_func(value,f"{s}[{i}]")
        elif type(obj).__name__ =="ndarray": #util.py自身がnumpyをimportしなくても動作するように文字列で対応
            recursive_func(obj.tolist(),s)
        else:
            ret[s]=obj
    recursive_func(root_obj,"")
    return ret

def single_keys_sorted(keys:List[str]):
    def cmp_word(a,b):
        if a==b:return 0
        a_type=type(a)
        b_type=type(b)
        if a_type is b_type:
            return -1 if a<b else 1
        type_score_dict={t:i for i,t in enumerate([None,int,str])}
        return -1 if type_score_dict[a_type]<type_score_dict[b_type] else 1

    def cmp_list(al:list,bl:list):
        for a,b in itertools.zip_longest(al,bl):
            res=cmp_word(a,b)
            if res!=0:
                return res
        return 0
    
    def split_key(key:str):
        return [int(g) if g.isnumeric() else g  for m in re.finditer(r'([^0-9]*)([0-9]*)', key) for g in m.groups() if g !='']
    
    def to_str_list(words:list):
        return [str(word) for word in words]

    splited_keys=[split_key(key)for key in keys]
    sorted_splited_keys=sorted(splited_keys,key=cmp_to_key(cmp_list))
    sorted_keys=["".join(to_str_list(words)) for words in sorted_splited_keys]
    return sorted_keys

class B:
    def __init__(self,v) -> None:
        self.bb=[v,v*2,v*3]
        pass
class A:
    def __init__(self) -> None:
        self.aa=[1,B(2)]
        self.c=3
        self.d=B(4)
        pass


    
if __name__ == '__main__':
    print("test")
    print([(i,value) for i,value in __builtins__.enumerate(["a","b","c"])])
    # print(hasattr(A(),"__dict__"))
    print(get_single_dict(A()))
    # print([A().__dict__,A().aa.__dict__,None])
    # print(get_single_dict(A()))